// HelloWorldCtl.h : Declaration of the CHelloWorldCtl
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>

// IHelloWorldCtl
[
	object,
	uuid(A711033A-46C0-48CE-8814-C6B6DA62521A),
	dual,
	helpstring("IHelloWorldCtl Interface"),
	pointer_default(unique)
]
__interface IHelloWorldCtl : public IDispatch
{
	[propget, id(1), helpstring("property text")] HRESULT text([out, retval] BSTR* pVal);
	[propput, id(1), helpstring("property text")] HRESULT text([in] BSTR newVal);
};


// CHelloWorldCtl
[
	coclass,
	threading("apartment"),
	vi_progid("HelloWorld.HelloWorldCtl"),
	progid("HelloWorld.HelloWorldCtl.1"),
	version(1.0),
	uuid("59E937ED-AC7E-407D-B40B-6545B1EECDE7"),
	helpstring("HelloWorldCtl Class"),
	support_error_info(IHelloWorldCtl),
	registration_script("control.rgs")
]
class ATL_NO_VTABLE CHelloWorldCtl : 
	public IHelloWorldCtl,
	public IPersistStreamInitImpl<CHelloWorldCtl>,
	public IOleControlImpl<CHelloWorldCtl>,
	public IOleObjectImpl<CHelloWorldCtl>,
	public IOleInPlaceActiveObjectImpl<CHelloWorldCtl>,
	public IViewObjectExImpl<CHelloWorldCtl>,
	public IOleInPlaceObjectWindowlessImpl<CHelloWorldCtl>,
	public IPersistStorageImpl<CHelloWorldCtl>,
	public ISpecifyPropertyPagesImpl<CHelloWorldCtl>,
	public IQuickActivateImpl<CHelloWorldCtl>,
	public IDataObjectImpl<CHelloWorldCtl>,
	public IProvideClassInfo2Impl<&__uuidof(CHelloWorldCtl), NULL>,
	public CComControl<CHelloWorldCtl>,
	public IPersistPropertyBagImpl<CHelloWorldCtl>,
	public IObjectSafetyImpl<CHelloWorldCtl, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>
{
public:

	CHelloWorldCtl()
	{
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)


BEGIN_PROP_MAP(CHelloWorldCtl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("text", 1, CHelloWorldCtl::GetObjectCLSID())
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()


BEGIN_MSG_MAP(CHelloWorldCtl)
	CHAIN_MSG_MAP(CComControl<CHelloWorldCtl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IHelloWorldCtl
public:
		HRESULT OnDraw(ATL_DRAWINFO& di)
		{
		RECT& rc = *(RECT*)di.prcBounds;
		// Set Clip region to the rectangle specified by di.prcBounds
		HRGN hRgnOld = NULL;
		if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
			hRgnOld = NULL;
		bool bSelectOldRgn = false;

		HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);

		if (hRgnNew != NULL)
		{
			bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
		}

		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		CW2A pszA(m_text);
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszA, 
			lstrlen(pszA));

		if (bSelectOldRgn)
			SelectClipRgn(di.hdcDraw, hRgnOld);

		return S_OK;
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}
	STDMETHOD(get_text)(BSTR* pVal);
	STDMETHOD(put_text)(BSTR newVal);

	// IObjectSafety implementation
/*	STDMETHODIMP GetInterfaceSafetyOptions( REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions )
	{
		ATLTRACE(_T("CNoteCtl::GetInterfaceSafetyOptions()\n"));
		*pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER |
			INTERFACESAFE_FOR_UNTRUSTED_DATA;
		*pdwEnabledOptions = *pdwSupportedOptions;
		::MessageBox(NULL, "get", "", 0);
		return S_OK;
	}

	STDMETHODIMP SetInterfaceSafetyOptions(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions)
	{
		ATLTRACE(_T("CNoteCtl::SetInterfaceSafetyOptions\n"));
		::MessageBox(NULL, "set", "", 0);
		return S_OK;
	}*/

private:
	CComBSTR m_text;
};

